use serde::Deserialize;
use serde::Serialize;

use super::ast_node::WasmAstNode;
use super::macros::to_wasm;
use super::to_wasm::ToWasm;
use crate::types::Code;
use crate::util::elisp_fact::ElispFact;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Debug, Serialize, Deserialize)]
pub struct WasmCode {
    pub(crate) value: String,
}

to_wasm!(
    WasmCode,
    Code<'s>,
    original,
    wasm_context,
    { WasmAstNode::Code(original) },
    { "code".into() },
    {
        Ok((
            Vec::new(),
            WasmCode {
                value: original.contents.to_owned(),
            },
        ))
    }
);
