use serde::Deserialize;
use serde::Serialize;

use super::ast_node::WasmAstNode;
use super::macros::to_wasm;
use super::to_wasm::ToWasm;
use crate::types::LatexFragment;
use crate::util::elisp_fact::ElispFact;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Debug, Serialize, Deserialize)]
pub struct WasmLatexFragment {
    pub(crate) value: String,
}

to_wasm!(
    WasmLatexFragment,
    LatexFragment<'s>,
    original,
    wasm_context,
    { WasmAstNode::LatexFragment(original) },
    { "latex-fragment".into() },
    {
        Ok((
            Vec::new(),
            WasmLatexFragment {
                value: original.value.to_owned(),
            },
        ))
    }
);
