use serde::Deserialize;
use serde::Serialize;

use super::ast_node::WasmAstNode;
use super::macros::to_wasm;
use super::to_wasm::ToWasm;
use crate::types::StatisticsCookie;
use crate::util::elisp_fact::ElispFact;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Debug, Serialize, Deserialize)]
pub struct WasmStatisticsCookie {
    pub(crate) value: String,
}

to_wasm!(
    WasmStatisticsCookie,
    StatisticsCookie<'s>,
    original,
    wasm_context,
    { WasmAstNode::StatisticsCookie(original) },
    { "statistics-cookie".into() },
    {
        Ok((
            Vec::new(),
            WasmStatisticsCookie {
                value: original.value.to_owned(),
            },
        ))
    }
);
