use serde::Deserialize;
use serde::Serialize;

use super::ast_node::WasmAstNode;
use super::macros::to_wasm;
use super::to_wasm::ToWasm;
use crate::types::Target;
use crate::util::elisp_fact::ElispFact;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Debug, Serialize, Deserialize)]
pub struct WasmTarget {
    pub(crate) value: String,
}

to_wasm!(
    WasmTarget,
    Target<'s>,
    original,
    wasm_context,
    { WasmAstNode::Target(original) },
    { "target".into() },
    {
        Ok((
            Vec::new(),
            WasmTarget {
                value: original.value.to_owned(),
            },
        ))
    }
);
