use serde::Deserialize;
use serde::Serialize;

use super::ast_node::WasmAstNode;
use super::macros::to_wasm;
use super::to_wasm::ToWasm;
use crate::types::Verbatim;
use crate::util::elisp_fact::ElispFact;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Debug, Serialize, Deserialize)]
pub struct WasmVerbatim {
    pub(crate) value: String,
}

to_wasm!(
    WasmVerbatim,
    Verbatim<'s>,
    original,
    wasm_context,
    { WasmAstNode::Verbatim(original) },
    { "verbatim".into() },
    {
        Ok((
            Vec::new(),
            WasmVerbatim {
                value: original.contents.to_owned(),
            },
        ))
    }
);
